<?php
error_reporting(E_ALL | E_STRICT);
// Initialize session

function authenticate($user, $password) {
	if (empty($user) || empty($password)) return false;

	$ldap_host = "ldaps://ldap.vsb.cz:636";

	$ldapconn = ldap_connect($ldap_host);
	if ($ldapconn) {
		ldap_set_option(NULL, LDAP_OPT_DEBUG_LEVEL, 7);
		ldap_set_option($ldapconn, LDAP_OPT_REFERRALS, 0);
		if (ldap_set_option($ldapconn,LDAP_OPT_PROTOCOL_VERSION, 3)) {
    		//echo "Using LDAP v3 \n";
		} else {	
		    //echo "Failed to set version to protocol 3 \n";	
		}

		$ldapbind = ldap_bind($ldapconn);
		if ($ldapbind) {
			$filter = "(uid=$user)";
			$base_dn = "o=VSB";

			$result = ldap_search($ldapconn, $base_dn, $filter);
			$entry = ldap_first_entry($ldapconn, $result);
			if (empty($entry)) {return false;}
			$user_dn = ldap_get_dn($ldapconn, $entry);

			//echo "User DN: ".$user_dn."\n";

			if ($bind = @ldap_bind($ldapconn, $user_dn, $password)) {
				$access=1;
				ldap_unbind($ldapconn);

				if ($access != 0) {
					// establish session variables
					$_SESSION['user'] = $user;
					$_SESSION['access'] = $access;
					return true;
				} else {
					// user has no rights
					return false;
				}
			} else {
				//echo("msg:'".ldap_error($ldap)."'</br>");
				//invalid name or password
				//echo 'ldap-errno: '.ldap_errno($ldap)."\n";
				//echo 'ldap-error: '.ldap_error($ldap)."\n";
				return false;
			}
		} else {
			echo "Chyba anonymniho prihlaseni"; 
		}
	} else {
		echo "Chyba spojeni na LDAP\n";
	}
}
?>
